DKPresenceUpdateRate = 0.333;

function DKPresence_OnLoad()
	local playerClass, englishClass = UnitClass("player");
	if englishClass == "DEATHKNIGHT" then
		DKPresenceFrame:RegisterEvent("VARIABLES_LOADED");
	end
end

function DKPresence_OnEvent(self, event, ...)
	if event == "VARIABLES_LOADED" then
		DKPresenceFrame:Show()
		DKPresenceFrame:RegisterEvent("PLAYER_TALENT_UPDATE")
	elseif event == "PLAYER_TALENT_UPDATE" then
		DKPresenceCheckPresence()
	end
end

function DKPresence_OnUpdate(self, elapsed)
	local playerClass, englishClass = UnitClass("player");
	if englishClass ~= "DEATHKNIGHT" then
		DKPresenceFrame:Hide();
	else
		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
		if (self.TimeSinceLastUpdate > DKPresenceUpdateRate) then
			DKPresenceCheckPresence();
			self.TimeSinceLastUpdate = 0;
		end
	end
end

function DKPresenceCheckPresence()
	icon, name, active, castable = GetShapeshiftFormInfo(1);
	if active then
		DKPresenceFrame:Hide();
	else
		icon, name, active, castable = GetShapeshiftFormInfo(2);
		if active then
			DKPresenceFrame:Hide();
		else
			icon, name, active, castable = GetShapeshiftFormInfo(3);
			if active then
				DKPresenceFrame:Hide();
			else
				tank = GetCombatRating(CR_DODGE);
				if tank > 0 then
					DKPresenceTex:SetVertexColor(1, 0, 0)
				else
					DKPresenceTex:SetVertexColor(0, 1, 1)
				end
				DKPresenceFrame:Show();
			end
		end
	end
end